// Copyright (c) 2013 - 2017 P. Calligaris and M. Mazzocco. 
// All rights reserved.
//
// Licensed under the MIT license <LICENSE-MIT or http://opensource.org/licenses/MIT>, 
// at your option. This file may not be copied, modified, or distributed except according
// to those terms.
//
// Useful functions as print a point on screen or save a collection of points on a file

#ifndef CUSTOM_LIBRARY_H_
#define CUSTOM_LIBRARY_H_

#include <vector>
#include <iostream>
#include <sstream>
#include <fstream>
#include <cstring>
#include <map>
#define _USE_MATH_DEFINES
// #include <math>
#include <cmath>
#include <cerrno>
#include <algorithm>
#include <limits>

static const double SMALL = 0.000001; 

extern std::map <size_t, std::vector<double> > hash_table;
extern std::pair<std::map<size_t, std::vector<double> >::iterator,bool> ret;
struct m_pair_{
            int type;
            int i;
            int j;
            int l;
            int k;
            double unk_1 = 0.0; //missin pijk (depends on the matching)
            double unk_2 = 0.0; //p.pinf always
            double unk_3 = 0.0; 
            double unk_4 = 0.0; 
            char flag[4];
};
std::size_t make_hash( std::vector<double> );
std::size_t make_hash_pi( std::vector<double> );
bool is_in_map( std::vector<double> , std::map <size_t, std::vector<double> > );
void put_in_map( std::vector<double> , std::map<size_t, std::vector<double> >& , std::pair<std::map<size_t, std::vector<double> >::iterator,bool>& );
void put_in_map_pi( std::vector<double> , std::map<size_t, std::vector<double> >& , std::pair<std::map<size_t, std::vector<double> >::iterator,bool>& );
double small_value( double );
void print_point( std::vector<double> );
void save_ind_on_file( std::vector<m_pair_> , std::string  );
void load_ind_from_file(  std::vector<m_pair_>& , std::string );
void print_points_on_file(  std::vector<m_pair_> , std::vector<std::vector<double> > , std::string );
bool exist_file( const std::string& );
double gen_value( double );
void print_orbit_on_file( std::vector<std::vector<double> > , std::string , std::string );
void print_orbit_on_file_m( std::vector<std::vector<double> > , std::string , std::string );
void merge_indices( std::vector<m_pair_> , std::vector<m_pair_>& );
void merge_table( std::vector< std::vector<double> > , std::vector< std::vector<double> >& );
std::string get_E45_fn( );
std::string get_matched_indices_fn( int );
std::string get_checked_ind_fn( int );
std::string get_strong_braided_ind_fn( int );
std::string get_soft_braided_ind_fn( int );
std::string get_nodup_indices_fn( );
void create_points( std::vector<m_pair_> , std::vector<std::vector<double> > , std::vector<std::vector<double> >& , int );
void create_anykind_points( std::vector<m_pair_> , std::vector<std::vector<double> > , std::vector<std::vector<double> >& );

#endif