// Copyright (c) 2013 - 2017 P. Calligaris and M. Mazzocco. 
// All rights reserved.
//
// Licensed under the MIT license <LICENSE-MIT or http://opensource.org/licenses/MIT>, 
// at your option. This file may not be copied, modified, or distributed except according
// to those terms.

#ifndef PVI_H_
#define PVI_H_

#include "custom_library.h"

#include <cmath>

class pvi{

    public:
    	//co-adjoint coordinates of a point q
    	struct pvi_coords {
    		double q1, q2, q3 ,qinf, q21, q31, q32, o1, o2, o3, o4, num_orb, num_points;	
    	};
        std::vector<pvi_coords> E45;
        template <typename T> void free_vec( T &  );
		void gen_points_table();        
        int max_recursion = 1000;
		void gen_orbit_( pvi_coords , std::vector<pvi_coords >& );
		pvi_coords pb1( pvi_coords );
		pvi_coords pb2( pvi_coords );
		pvi_coords pb3( pvi_coords );
		std::size_t make_hash_q( pvi_coords q );
		std::pair<std::map<size_t, pvi_coords >::iterator,bool> ret;
		std::pair<std::map<size_t, pvi_coords >::iterator,bool> ret_orbit;
        std::map <size_t, pvi_coords > hash_table;
        std::map <size_t, pvi_coords > hash_table_orbit;
        std::map <size_t, pvi_coords > hash_table_p13p23;
        std::map <size_t, pvi_coords > hash_table_all;
		void put_in_map_q( pvi_coords , std::map<size_t, pvi_coords >& , std::pair<std::map<size_t, pvi_coords >::iterator,bool>& );
        std::vector<pvi_coords > gen_q_points_table( std::vector<m_pair_> , std::vector<pvi::pvi_coords > );
        void print_q_point( pvi_coords );
        void correct_values( pvi_coords& );   
        void save_E45_on_file( std::vector<pvi_coords> , std::string );
		void load_E45_from_file( std::vector<pvi_coords>& , std::string );
		double jf_cubic( pvi::pvi_coords );  
		bool check_q_okamoto_id( pvi::pvi::pvi_coords );
		bool is_compatible_w_okam_red( pvi::pvi_coords );
		int check_q_LT( pvi::pvi_coords );
        pvi();
        ~pvi();
		pvi_coords d4_1( pvi::pvi_coords );pvi_coords d4_2( pvi::pvi_coords );pvi_coords d4_3( pvi::pvi_coords );pvi_coords d4_4( pvi::pvi_coords );
		pvi_coords d4_5( pvi::pvi_coords );pvi_coords d4_6( pvi::pvi_coords );pvi_coords d4_7( pvi::pvi_coords );pvi_coords d4_8( pvi::pvi_coords );
		pvi_coords d4_9( pvi::pvi_coords );pvi_coords d4_10( pvi::pvi_coords );pvi_coords d4_11( pvi::pvi_coords );pvi_coords d4_12( pvi::pvi_coords );
		pvi_coords d4_13( pvi::pvi_coords );pvi_coords d4_14( pvi::pvi_coords );pvi_coords d4_15( pvi::pvi_coords );pvi_coords d4_16( pvi::pvi_coords );
		pvi_coords d4_17( pvi::pvi_coords );pvi_coords d4_18( pvi::pvi_coords );pvi_coords d4_19( pvi::pvi_coords );pvi_coords d4_20( pvi::pvi_coords );
		pvi_coords d4_21( pvi::pvi_coords );pvi_coords d4_22( pvi::pvi_coords );pvi_coords d4_23( pvi::pvi_coords );pvi_coords d4_24( pvi::pvi_coords );
// 		pvi_coords a1_( pvi_coords  );
// 		pvi_coords a2_( pvi_coords  );
// 		pvi_coords a3_( pvi_coords  );
// 		pvi_coords srho_( pvi_coords  );
// 		pvi_coords srho_sx_( pvi_coords  );
		pvi_coords perm123_( pvi_coords );
		pvi_coords perm12_( pvi_coords );
		pvi_coords sign1_( pvi_coords );
		pvi_coords sign2_( pvi_coords );
		pvi_coords sign3_( pvi_coords );
		pvi_coords r1_( pvi_coords );
		pvi_coords r2_( pvi_coords );
		pvi_coords r3_( pvi_coords );
		pvi_coords P13_( pvi_coords );
		pvi_coords P23_( pvi_coords );
		std::vector<pvi_coords > gen_S3_permutations_( pvi_coords );
		std::vector<pvi_coords > gen_sign_flips_( pvi_coords );
		std::vector<pvi_coords > gen_K4_( pvi_coords );
		void gen_P13_P23_group_( pvi_coords , std::vector<pvi_coords >& );
		std::vector<pvi_coords > gen_24sol_qis_( pvi_coords );
// 		pvi_coords get_row_from_table_( std::vector<double>  );
	private:
};       
#endif