// Copyright (c) 2013 - 2017 P. Calligaris and M. Mazzocco. 
// All rights reserved.
//
// Licensed under the MIT license <LICENSE-MIT or http://opensource.org/licenses/MIT>, 
// at your option. This file may not be copied, modified, or distributed except according
// to those terms.
//
// Algorithm 11 : Factorize every A_N w.r.t. the group <P_13,P_23,P_34>
// The result is saved in the file "./C2"

#include "g2.h"
#include "custom_library.h"
#include <set>
#include <dirent.h>

int main( )
{
    g2 g;

	std::vector<g2::g2_coords > p_points;
    std::vector<g2::g2_coords > p_points_nodup;
    std::vector<g2::g2_coords_pi > pi_vec,pi_vec_t;
    g2::g2_coords p, braided_el, transformed_p, permuted_p;
    int sz_1 = 0;
	int full_size;
	int total;
    int p_points_nodup_size = p_points_nodup.size();
    int cc2 = 0;

	std::vector<g2::g2_coords > hash_tables_quotient_orbits;
	std::map<size_t, std::vector<double> > hash_table_loc,hash_table_loc_t,hash_table_loc_t2,hash_table_pi;
	std::pair<std::map<size_t, std::vector<double> >::iterator,bool> ret;
    std::map<size_t, std::vector<double> >::iterator it;
    std::vector<std::map<size_t, std::vector<double> > >::iterator it_o, it_o2;
    
	std::vector<g2::g2_coords > orbit_points;
	std::vector<std::map<size_t, std::vector<double> > > hash_tables_orbits,hash_tables_orbits_t,hash_tables_orbits_t2;
	std::vector<std::vector<g2::g2_coords > > orbits;
    std::vector<double> double_p,double_p_t;
    std::vector<g2::g2_coords> points_p, points_p_same_length;
    std::vector<std::vector<g2::g2_coords> > points_p_ordered_by_length(3073);

    std::vector<int > sizes;
    std::set<int> set_pi;
    bool not_relevant = false;  
    // Following the list of all subsets A_N, where each element in A_N have the same ordered (p1,...,p4,pinf)
    // the symmetries in the group <sign_i,(12)(34),(1234)> extended with P1inf, to reorder the (p1,...,p4,pinf) are explicitly written
    // each A_N  start with a blank line
    
    p.p1 = 0; p.p2 = 0; p.p3 = -1; p.p4 = 0; p.pinf = sqrt(2); p.p21 = -sqrt(2); p.p31 = -1; p.p32 = -sqrt(2); p.p41 = 0; p.p42 = 0; p.p43 = -1; p.p321 = 0; p.p432 = 0; p.p431 = -1; p.p421 = -sqrt(2);
    points_p_ordered_by_length.at(36).push_back(p);
    g.correct_values(p);
    g.print_g2_coords(p);
    p.p1 = 1; p.p2 = 0; p.p3 = sqrt(2); p.p4 = 0; p.pinf = 0; p.p21 = -1; p.p31 = 0; p.p32 = -sqrt(2); p.p41 = 0; p.p42 = sqrt(2); p.p43 = 1; p.p321 = -sqrt(2); p.p432 = 1; p.p431 = 0; p.p421 = 0;    
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_7(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(p))))));
    points_p_ordered_by_length.at(36).push_back(transformed_p);
    g.print_g2_coords(transformed_p);
    p.p1 = 0; p.p2 = 1; p.p3 = sqrt(2); p.p4 = 0; p.pinf = 0; p.p21 = 0; p.p31 = 1; p.p32 = 0; p.p41 = sqrt(2); p.p42 = 1; p.p43 = 0; p.p321 = 0; p.p432 = sqrt(2); p.p431 = 1; p.p421 = sqrt(2);
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_7(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_5(p)))))));
    g.print_g2_coords(transformed_p);
    points_p_ordered_by_length.at(36).push_back(transformed_p);
    p.p1 = -sqrt(2); p.p2 = 0; p.p3 = 0; p.p4 = 1; p.pinf = 0; p.p21 = -1; p.p31 = -sqrt(2); p.p32 = -sqrt(2); p.p41 = 0; p.p42 = 0; p.p43 = 1; p.p321 = 1; p.p432 = -sqrt(2); p.p431 = -sqrt(2); p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_sign_7(g.el_perm_5(g.el_P_1inf(g.el_sign_1(p))));
    g.print_g2_coords(transformed_p);
    points_p_ordered_by_length.at(36).push_back(transformed_p);
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = -1; p.pinf = -sqrt(2); p.p21 = 0; p.p31 = 0; p.p32 = sqrt(2); p.p41 = -1; p.p42 = sqrt(2); p.p43 = -1; p.p321 = sqrt(2); p.p432 = 0; p.p431 = 1; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_perm_5(p));
    g.print_g2_coords(transformed_p);
    points_p_ordered_by_length.at(36).push_back(transformed_p);
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = 1; p.pinf = 1; p.p21 = 0; p.p31 = 2; p.p32 = 0; p.p41 = -1; p.p42 = -1; p.p43 = 1; p.p321 = 0; p.p432 = -1; p.p431 = 1; p.p421 = -1;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(36).push_back(p);
	p.p1 = 1; p.p2 = 0; p.p3 = 1; p.p4 = 0; p.pinf = 0; p.p21 = 1; p.p31 = 0; p.p32 = 1; p.p41 = 1; p.p42 = 0; p.p43 = 1; p.p321 = 2; p.p432 = -1; p.p431 = 2; p.p421 = -1;
	g.correct_values(p);
	transformed_p = g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)));
    g.print_g2_coords(transformed_p);
	points_p_ordered_by_length.at(36).push_back(transformed_p);
	p.p1 = 1; p.p2 = 0; p.p3 = 0; p.p4 = -1; p.pinf = 0; p.p21 = -1; p.p31 = -1; p.p32 = 0; p.p41 = -2; p.p42 = -1; p.p43 = -1; p.p321 = 1; p.p432 = 1; p.p431 = 0; p.p421 = 0;
	g.correct_values(p);
	transformed_p = g.el_sign_1(g.el_sign_15(g.el_P_1inf(g.el_sign_1(p))));
    g.print_g2_coords(transformed_p);
	points_p_ordered_by_length.at(36).push_back(transformed_p);

	p.p1 = -1; p.p2 = 1; p.p3 = sqrt(2); p.p4 = 1; p.pinf = -sqrt(2); p.p21 = -1; p.p31 = -sqrt(2); p.p32 = 0; p.p41 = 1; p.p42 = 1; p.p43 = sqrt(2); p.p321 = -sqrt(2); p.p432 = sqrt(2); p.p431 = 0; p.p421 = 0;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(40).push_back(p);
    p.p1 = (-1 + sqrt(5))/2.; p.p2 = (-1 + sqrt(5))/2.; p.p3 = (1 + sqrt(5))/2.; p.p4 = (-1 + sqrt(5))/2.; p.pinf = (-1 - sqrt(5))/2.; p.p21 = (1 - sqrt(5))/2.; p.p31 = 0; p.p32 = 1; p.p41 = (1 - sqrt(5))/2.; p.p42 = (1 - sqrt(5))/2.; p.p43 = 0; p.p321 = -1; p.p432 = 0; p.p431 = 0; p.p421 = -2;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(40).push_back(p);
	p.p1 = (-1 - sqrt(5))/2.; p.p2 = (-1 - sqrt(5))/2.; p.p3 = (1 + sqrt(5))/2.; p.p4 = (1 - sqrt(5))/2.; p.pinf = (1 - sqrt(5))/2.; p.p21 = (-1 + sqrt(5))/2.; p.p31 = (-1 - sqrt(5))/2.; p.p32 = (-1 - sqrt(5))/2.; p.p41 = 1; p.p42 = 1; p.p43 = -1; p.p321 = 1; p.p432 = 1; p.p431 = 1; p.p421 = -1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(40).push_back(p);

	p.p1 = (-1 + sqrt(5))/2.; p.p2 = (-1 + sqrt(5))/2.; p.p3 = (-1 + sqrt(5))/2.; p.p4 = (1 - sqrt(5))/2.; p.pinf = (1 + sqrt(5))/2.; p.p21 = (1 - sqrt(5))/2.; p.p31 = (1 - sqrt(5))/2.; p.p32 = (-1 - sqrt(5))/2.; p.p41 = -1; p.p42 = (-1 + sqrt(5))/2.; p.p43 = (-1 + sqrt(5))/2.; p.p321 = -1; p.p432 = 1; p.p431 = 1; p.p421 = 1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(45).push_back(p);
	p.p1 = (1 + sqrt(5))/2.; p.p2 = (1 + sqrt(5))/2.; p.p3 = (1 + sqrt(5))/2.; p.p4 = (1 + sqrt(5))/2.; p.pinf = (-1 + sqrt(5))/2.; p.p21 = (1 + sqrt(5))/2.; p.p31 = 1; p.p32 = (1 + sqrt(5))/2.; p.p41 = 1; p.p42 = 2; p.p43 = 1; p.p321 = 1; p.p432 = (1 + sqrt(5))/2.; p.p431 = 0; p.p421 = (1 + sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(45).push_back(p);		

	p.p1 = sqrt(2); p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = sqrt(2); p.p21 = sqrt(2); p.p31 = -1; p.p32 = sqrt(2); p.p41 = 0; p.p42 = 0; p.p43 = 1; p.p321 = 1; p.p432 = 1; p.p431 = 0; p.p421 = 0;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(48).push_back(p);	
	p.p1 = 0; p.p2 = -sqrt(2); p.p3 = 0; p.p4 = 0; p.pinf = sqrt(2); p.p21 = 0; p.p31 = 1; p.p32 = 1; p.p41 = sqrt(2); p.p42 = 0; p.p43 = 0; p.p321 = -sqrt(2); p.p432 = 1; p.p431 = -1; p.p421 = 0;
	g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_3(g.el_perm_5(p)));
	g.print_g2_coords(transformed_p);
	points_p_ordered_by_length.at(48).push_back(transformed_p);

	p.p1 = 0; p.p2 = 0; p.p3 = -1; p.p4 = 0; p.pinf = 0; p.p21 = sqrt(2); p.p31 = -sqrt(2); p.p32 = 1; p.p41 = -1; p.p42 = 0; p.p43 = 0; p.p321 = 0; p.p432 = sqrt(2); p.p431 = 0; p.p421 = -1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(72).push_back(p);	
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = 1; p.pinf = 0; p.p21 = 0; p.p31 = -sqrt(2); p.p32 = 0; p.p41 = -1; p.p42 = 1; p.p43 = -sqrt(2); p.p321 = -sqrt(2); p.p432 = 0; p.p431 = -sqrt(2); p.p421 = -1;
	g.correct_values(p);
    transformed_p =  g.el_P_1inf(g.el_sign_1(g.el_sign_10(g.el_perm_5(p))));
    g.print_g2_coords(transformed_p);
	points_p_ordered_by_length.at(72).push_back(transformed_p);	
	p.p1 = 0; p.p2 = -1; p.p3 = 0; p.p4 = 0; p.pinf = 0; p.p21 = 0; p.p31 = -1; p.p32 = sqrt(2); p.p41 = 0; p.p42 = 1; p.p43 = -sqrt(2); p.p321 = 0; p.p432 = sqrt(2); p.p431 = 1; p.p421 = -sqrt(2);
    g.correct_values(p);
    transformed_p =  g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)));
    points_p_ordered_by_length.at(72).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);
    p.p1 = 0; p.p2 = 1; p.p3 = 0; p.p4 = 0; p.pinf = 0; p.p21 = -1; p.p31 = 2; p.p32 = 1; p.p41 = 0; p.p42 = 0; p.p43 = 0; p.p321 = 1; p.p432 = -sqrt(2); p.p431 = 0; p.p421 = -sqrt(2);
    g.correct_values(p);
    transformed_p =  g.el_sign_10(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p))));
    points_p_ordered_by_length.at(72).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);
    p.p1 = -sqrt(2); p.p2 = 0; p.p3 = 0; p.p4 = -1; p.pinf = -sqrt(2); p.p21 = 0; p.p31 = -1; p.p32 = -1; p.p41 = sqrt(2); p.p42 = -sqrt(2); p.p43 = 0; p.p321 = 0; p.p432 = 1; p.p431 = 1; p.p421 = 1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(72).push_back(p);	
    p.p1 = -1; p.p2 = 0; p.p3 = -sqrt(2); p.p4 = 0; p.pinf = sqrt(2); p.p21 = 0; p.p31 = 0; p.p32 = 0; p.p41 = 0; p.p42 = 2; p.p43 = 0; p.p321 = -1; p.p432 = -sqrt(2); p.p431 = -1; p.p421 = -1;
	g.correct_values(p);
    transformed_p =  g.el_sign_1(g.el_sign_3(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)))))))))))))))));
    g.print_g2_coords(transformed_p);
	points_p_ordered_by_length.at(72).push_back(transformed_p);	
    
    p.p1 = (-1 + sqrt(5))/2.; p.p2 = (1 - sqrt(5))/2.; p.p3 = -1; p.p4 = (-1 + sqrt(5))/2.; p.pinf = (1 + sqrt(5))/2.; p.p21 = (-1 + sqrt(5))/2.; p.p31 = 1; p.p32 = -1; p.p41 = (1 - sqrt(5))/2.; p.p42 = -1; p.p43 = 0; p.p321 = (1 - sqrt(5))/2.; p.p432 = 0; p.p431 = 0; p.p421 = (1 - sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(81).push_back(p);	
    p.p1 = (1 + sqrt(5))/2.; p.p2 = (1 + sqrt(5))/2.; p.p3 = -1; p.p4 = (-1 - sqrt(5))/2.; p.pinf = (-1 + sqrt(5))/2.; p.p21 = (1 + sqrt(5))/2.; p.p31 = (1 - sqrt(5))/2.; p.p32 = (-1 - sqrt(5))/2.; p.p41 = -1; p.p42 = -1; p.p43 = 1; p.p321 = -1; p.p432 = 1; p.p431 = 1; p.p421 = (1 - sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(81).push_back(p);    
    
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = -sqrt(2); p.p21 = 0; p.p31 = -sqrt(2); p.p32 = -1; p.p41 = sqrt(2); p.p42 = -1; p.p43 = 0; p.p321 = -1; p.p432 = sqrt(2); p.p431 = 0; p.p421 = -1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(96).push_back(p);	    
    p.p1 = sqrt(2); p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = 0; p.p21 = 1; p.p31 = -sqrt(2); p.p32 = sqrt(2); p.p41 = 1; p.p42 = -2; p.p43 = sqrt(2); p.p321 = 1; p.p432 = 0; p.p431 = 1; p.p421 = -sqrt(2);
    g.correct_values(p);
    transformed_p =  g.el_sign_1(g.el_P_1inf(g.el_sign_1(p)));
    points_p_ordered_by_length.at(96).push_back(transformed_p);	
    g.print_g2_coords(transformed_p); 
    p.p1 = -sqrt(2); p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = 0; p.p21 = 1; p.p31 = 0; p.p32 = 1; p.p41 = 0; p.p42 = 0; p.p43 = sqrt(2); p.p321 = -sqrt(2); p.p432 = 1; p.p431 = -2; p.p421 = 1;
    g.correct_values(p);
    transformed_p =  g.el_P_1inf(g.el_sign_1(p));
    points_p_ordered_by_length.at(96).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = 0; p.p2 = 0; p.p3 = sqrt(2); p.p4 = 0; p.pinf = 0; p.p21 = -1; p.p31 = -1; p.p32 = -1; p.p41 = -1; p.p42 = -2; p.p43 = -1; p.p321 = -sqrt(2); p.p432 = -sqrt(2); p.p431 = 0; p.p421 = 0;
    g.correct_values(p);
    transformed_p =  g.el_sign_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(p)))));
    points_p_ordered_by_length.at(96).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = (-1 - sqrt(5))/2.; p.p2 = (-1 - sqrt(5))/2.; p.p3 = (1 + sqrt(5))/2.; p.p4 = (-1 - sqrt(5))/2.; p.pinf = (-1 - sqrt(5))/2.; p.p21 = (1 + sqrt(5))/2.; p.p31 = (-1 - sqrt(5))/2.; p.p32 = (-1 - sqrt(5))/2.; p.p41 = 2; p.p42 = 1; p.p43 = -1; p.p321 = (1 + sqrt(5))/2.; p.p432 = 1; p.p431 = (1 + sqrt(5))/2.; p.p421 = (-1 - sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(96).push_back(p);	
	p.p1 = (1 - sqrt(5))/2.; p.p2 = (1 - sqrt(5))/2.; p.p3 = (1 - sqrt(5))/2.; p.p4 = (1 - sqrt(5))/2.; p.pinf = (1 - sqrt(5))/2.; p.p21 = (1 - sqrt(5))/2.; p.p31 = (-1 - sqrt(5))/2.; p.p32 = (1 - sqrt(5))/2.; p.p41 = (1 - sqrt(5))/2.; p.p42 = (1 - sqrt(5))/2.; p.p43 = (1 - sqrt(5))/2.; p.p321 = 1; p.p432 = (1 - sqrt(5))/2.; p.p431 = 1; p.p421 = 2;    
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(96).push_back(p);
	p.p1 = 0; p.p2 = 0; p.p3 = 1; p.p4 = 0; p.pinf = -1; p.p21 = 2; p.p31 = 0; p.p32 = 0; p.p41 = -sqrt(2); p.p42 = sqrt(2); p.p43 = -1; p.p321 = 1; p.p432 = sqrt(2); p.p431 = -sqrt(2); p.p421 = 0;    
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(96).push_back(p);
	p.p1 = 0; p.p2 = 0; p.p3 = 1; p.p4 = 0; p.pinf = -1; p.p21 = 0; p.p31 = -1; p.p32 = sqrt(2); p.p41 = 0; p.p42 = 0; p.p43 = 0; p.p321 = 0; p.p432 = 1; p.p431 = sqrt(2); p.p421 = -2;    
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(96).push_back(p);
	p.p1 = 0; p.p2 = 0; p.p3 = -1; p.p4 = 1; p.pinf = 0; p.p21 = -1; p.p31 = 0; p.p32 = 0; p.p41 = -sqrt(2); p.p42 = 0; p.p43 = -1; p.p321 = -1; p.p432 = -sqrt(2); p.p431 = 0; p.p421 = -1;    
    g.correct_values(p);
    transformed_p =  g.el_sign_1(g.el_sign_10(g.el_perm_5(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p))))));
    points_p_ordered_by_length.at(96).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);    
    p.p1 = 0; p.p2 = -1; p.p3 = 0; p.p4 = -1; p.pinf = 0; p.p21 = -sqrt(2); p.p31 = -1; p.p32 = -sqrt(2); p.p41 = 0; p.p42 = 0; p.p43 = 0; p.p321 = 1; p.p432 = 0; p.p431 = -1; p.p421 = 0;
    g.correct_values(p);
    transformed_p =  g.el_sign_1(g.el_sign_10(g.el_sign_3(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p))))));
    points_p_ordered_by_length.at(96).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);
     
    p.p1 = (-1 - sqrt(5))/2.; p.p2 = 1; p.p3 = (1 + sqrt(5))/2.; p.p4 = -1; p.pinf = (-1 + sqrt(5))/2.; p.p21 = (-1 - sqrt(5))/2.; p.p31 = -1; p.p32 = (1 + sqrt(5))/2.; p.p41 = (1 + sqrt(5))/2.; p.p42 = (-1 + sqrt(5))/2.; p.p43 = -1; p.p321 = (-1 - sqrt(5))/2.; p.p432 = 0; p.p431 = (1 + sqrt(5))/2.; p.p421 = 0;    
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(105).push_back(p); 
	p.p1 = (1 + sqrt(5))/2.; p.p2 = (-1 - sqrt(5))/2.; p.p3 = -1; p.p4 = -1; p.pinf = (1 - sqrt(5))/2.; p.p21 = -1; p.p31 = 0; p.p32 = 0; p.p41 = (-1 - sqrt(5))/2.; p.p42 = 1; p.p43 = (1 + sqrt(5))/2.; p.p321 = -1; p.p432 = -1; p.p431 = (1 + sqrt(5))/2.; p.p421 = (1 + sqrt(5))/2.;   
    g.correct_values(p);
    transformed_p = g.el_sign_15(g.el_sign_1(g.el_sign_3(g.el_sign_10(g.sigma3(g.el_perm_5(g.el_perm_1(p)))))));
    points_p_ordered_by_length.at(105).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);   
    p.p1 = 1; p.p2 = (1 - sqrt(5))/2.; p.p3 = (1 - sqrt(5))/2.; p.p4 = -1; p.pinf = (1 + sqrt(5))/2.; p.p21 = (1 - sqrt(5))/2.; p.p31 = (1 - sqrt(5))/2.; p.p32 = (-1 - sqrt(5))/2.; p.p41 = -1; p.p42 = 0; p.p43 = 0; p.p321 = (1 - sqrt(5))/2.; p.p432 = 1; p.p431 = -1; p.p421 = -1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(105).push_back(p); 
    p.p1 = (1 - sqrt(5))/2.; p.p2 = 1; p.p3 = (1 - sqrt(5))/2.; p.p4 = -1; p.pinf = (1 + sqrt(5))/2.; p.p21 = (1 - sqrt(5))/2.; p.p31 = (1 - sqrt(5))/2.; p.p32 = (-1 - sqrt(5))/2.; p.p41 = -1; p.p42 = -1; p.p43 = 0; p.p321 = (1 - sqrt(5))/2.; p.p432 = 0; p.p431 = (1 + sqrt(5))/2.; p.p421 = (-1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))))))))));
    points_p_ordered_by_length.at(105).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    
    p.p1 = (1 + sqrt(5))/2.; p.p2 = 1; p.p3 = (-1 - sqrt(5))/2.; p.p4 = (-1 - sqrt(5))/2.; p.pinf = (1 + sqrt(5))/2.; p.p21 = (1 + sqrt(5))/2.; p.p31 = (1 - sqrt(5))/2.; p.p32 = (-1 - sqrt(5))/2.; p.p41 = -2; p.p42 = 0; p.p43 = 2; p.p321 = (-1 - sqrt(5))/2.; p.p432 = 1; p.p431 = (1 + sqrt(5))/2.; p.p421 = -1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(108).push_back(p);    
    p.p1 = (-1 + sqrt(5))/2.; p.p2 = (1 - sqrt(5))/2.; p.p3 = (-1 + sqrt(5))/2.; p.p4 = 1; p.pinf = (1 - sqrt(5))/2.; p.p21 = -1; p.p31 = (1 - sqrt(5))/2.; p.p32 = -2; p.p41 = (-1 + sqrt(5))/2.; p.p42 = (1 - sqrt(5))/2.; p.p43 = 0; p.p321 = (1 - sqrt(5))/2.; p.p432 = -1; p.p431 = 1; p.p421 = (-1 + sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(108).push_back(p);      
    
    p.p1 = 1; p.p2 = 0; p.p3 = -1; p.p4 = 0; p.pinf = -1; p.p21 = 0; p.p31 = -1; p.p32 = sqrt(2); p.p41 = -sqrt(2); p.p42 = -1; p.p43 = 0; p.p321 = sqrt(2); p.p432 = 1; p.p431 = 0; p.p421 = 0;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(120).push_back(p);    
	p.p1 = 0; p.p2 = 0; p.p3 = -1; p.p4 = -1; p.pinf = 1; p.p21 = 1; p.p31 = -sqrt(2); p.p32 = 0; p.p41 = -sqrt(2); p.p42 = sqrt(2); p.p43 = 0; p.p321 = 0; p.p432 = 0; p.p431 = sqrt(2); p.p421 = -1;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_3(g.el_sign_10(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))))));
    points_p_ordered_by_length.at(120).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     

    p.p1 = (-1 + sqrt(5))/2.; p.p2 = 1; p.p3 = (1 - sqrt(5))/2.; p.p4 = (1 - sqrt(5))/2.; p.pinf = -1; p.p21 = (-1 + sqrt(5))/2.; p.p31 = -1; p.p32 = (1 - sqrt(5))/2.; p.p41 = -1; p.p42 = (1 - sqrt(5))/2.; p.p43 = (-1 - sqrt(5))/2.; p.p321 = (-1 + sqrt(5))/2.; p.p432 = (1 - sqrt(5))/2.; p.p431 = 0; p.p421 = (-1 + sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(144).push_back(p);     
    p.p1 = 1; p.p2 = (-1 + sqrt(5))/2.; p.p3 = (1 - sqrt(5))/2.; p.p4 = -1; p.pinf = (1 - sqrt(5))/2.; p.p21 = (1 + sqrt(5))/2.; p.p31 = (-1 - sqrt(5))/2.; p.p32 = (1 + sqrt(5))/2.; p.p41 = -1; p.p42 = 1; p.p43 = -1; p.p321 = 0; p.p432 = (-1 - sqrt(5))/2.; p.p431 = (-1 + sqrt(5))/2.; p.p421 = (1 - sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_3(g.el_sign_15(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))));
    points_p_ordered_by_length.at(144).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = 1; p.p2 = (1 - sqrt(5))/2.; p.p3 = 1; p.p4 = (-1 + sqrt(5))/2.; p.pinf = (-1 + sqrt(5))/2.; p.p21 = (-1 - sqrt(5))/2.; p.p31 = 1; p.p32 = 1; p.p41 = (-1 + sqrt(5))/2.; p.p42 = (-1 + sqrt(5))/2.; p.p43 = 0; p.p321 = (1 - sqrt(5))/2.; p.p432 = 0; p.p431 = -1; p.p421 = (-1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_10(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))));
    points_p_ordered_by_length.at(144).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);    
    p.p1 = (-1 - sqrt(5))/2.; p.p2 = (-1 - sqrt(5))/2.; p.p3 = -1; p.p4 = (1 + sqrt(5))/2.; p.pinf = -1; p.p21 = (1 + sqrt(5))/2.; p.p31 = (1 + sqrt(5))/2.; p.p32 = 1; p.p41 = -2; p.p42 = -1; p.p43 = 0; p.p321 = (-1 - sqrt(5))/2.; p.p432 = 0; p.p431 = 1; p.p421 = (1 + sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(144).push_back(p);       
    p.p1 = -1; p.p2 = (-1 - sqrt(5))/2.; p.p3 = -1; p.p4 = (-1 - sqrt(5))/2.; p.pinf = (1 + sqrt(5))/2.; p.p21 = 1; p.p31 = (1 + sqrt(5))/2.; p.p32 = 1; p.p41 = 1; p.p42 = (-1 + sqrt(5))/2.; p.p43 = 1; p.p321 = -1; p.p432 = (1 - sqrt(5))/2.; p.p431 = -2; p.p421 = (1 - sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_15(g.el_sign_1(g.el_P_1inf(g.el_sign_1(p))));
    points_p_ordered_by_length.at(144).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = (1 + sqrt(5))/2.; p.p2 = (-1 - sqrt(5))/2.; p.p3 = 1; p.p4 = -1; p.pinf = (1 + sqrt(5))/2.; p.p21 = (-1 - sqrt(5))/2.; p.p31 = (1 + sqrt(5))/2.; p.p32 = 0; p.p41 = 0; p.p42 = (1 + sqrt(5))/2.; p.p43 = -2; p.p321 = -1; p.p432 = (1 + sqrt(5))/2.; p.p431 = (-1 - sqrt(5))/2.; p.p421 = (-1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_15(g.el_sign_1(g.el_sign_10(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)))))))));
    points_p_ordered_by_length.at(144).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);      
    p.p1 = 0; p.p2 = 1; p.p3 = 0; p.p4 = 0; p.pinf = sqrt(2); p.p21 = 0; p.p31 = 2; p.p32 = 0; p.p41 = 1; p.p42 = -sqrt(2); p.p43 = -1; p.p321 = 1; p.p432 = -1; p.p431 = 0; p.p421 = 0;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(144).push_back(p);
	p.p1 = -sqrt(2); p.p2 = 0; p.p3 = 0; p.p4 = -1; p.pinf = 0; p.p21 = -1; p.p31 = 1; p.p32 = 2; p.p41 = 0; p.p42 = -sqrt(2); p.p43 = sqrt(2); p.p321 = -sqrt(2); p.p432 = -1; p.p431 = -1; p.p421 = 1;
    g.correct_values(p);
    transformed_p = g.el_sign_3(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))));
    points_p_ordered_by_length.at(144).push_back(transformed_p);	
    g.print_g2_coords(transformed_p); 
    p.p1 = 0; p.p2 = 0; p.p3 = sqrt(2); p.p4 = 0; p.pinf = -1; p.p21 = 1; p.p31 = 1; p.p32 = -1; p.p41 = 0; p.p42 = -1; p.p43 = -1; p.p321 = 0; p.p432 = -sqrt(2); p.p431 = 0; p.p421 = -sqrt(2);
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_3(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(p)))))));
    points_p_ordered_by_length.at(144).push_back(transformed_p);	
    g.print_g2_coords(transformed_p); 
    p.p1 = sqrt(2); p.p2 = 0; p.p3 = -1; p.p4 = 0; p.pinf = 0; p.p21 = 1; p.p31 = 0; p.p32 = 0; p.p41 = -1; p.p42 = 1; p.p43 = sqrt(2); p.p321 = 0; p.p432 = -1; p.p431 = 2; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_3(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))));
    points_p_ordered_by_length.at(144).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    
    p.p1 = 2; p.p2 = 2; p.p3 = -2; p.p4 = -2; p.pinf = -2; p.p21 = (1 - sqrt(5))/2.; p.p31 = -1; p.p32 = (-1 + sqrt(5))/2.; p.p41 = (-1 - sqrt(5))/2.; p.p42 = (-1 - sqrt(5))/2.; p.p43 = 1; p.p321 = (1 + sqrt(5))/2.; p.p432 = -1; p.p431 = -1; p.p421 = 2;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(192).push_back(p);
	p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = 0; p.p21 = -sqrt(2); p.p31 = -2; p.p32 = -sqrt(2); p.p41 = -1; p.p42 = -sqrt(2); p.p43 = -1; p.p321 = 0; p.p432 = -1; p.p431 = 0; p.p421 = 1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(192).push_back(p);
	p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = 0; p.p21 = 1; p.p31 = -1; p.p32 = 1; p.p41 = 1; p.p42 = 0; p.p43 = -1; p.p321 = sqrt(2); p.p432 = -sqrt(2); p.p431 = 0; p.p421 = sqrt(2);
    g.correct_values(p);
    transformed_p = g.el_P_1inf(g.el_sign_1(p));
    points_p_ordered_by_length.at(192).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);  	

    p.p1 = 0; p.p2 = 0; p.p3 = (1 - sqrt(5))/2.; p.p4 = (1 + sqrt(5))/2.; p.pinf = (1 - sqrt(5))/2.; p.p21 = (-1 + sqrt(5))/2.; p.p31 = 1; p.p32 = 1; p.p41 = (1 - sqrt(5))/2.; p.p42 = (1 - sqrt(5))/2.; p.p43 = (-1 + sqrt(5))/2.; p.p321 = -1; p.p432 = 1; p.p431 = 1; p.p421 = 1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(200).push_back(p);    
    p.p1 = 0; p.p2 = (-1 - sqrt(5))/2.; p.p3 = 0; p.p4 = (-1 + sqrt(5))/2.; p.pinf = (1 - sqrt(5))/2.; p.p21 = (-1 + sqrt(5))/2.; p.p31 = (1 + sqrt(5))/2.; p.p32 = 0; p.p41 = 0; p.p42 = 0; p.p43 = -1; p.p321 = -1; p.p432 = (1 + sqrt(5))/2.; p.p431 = 0; p.p421 = 1;
    g.correct_values(p);
    transformed_p = g.el_sign_15(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))));
    points_p_ordered_by_length.at(200).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);  	    
    p.p1 = (1 + sqrt(5))/2.; p.p2 = 0; p.p3 = 0; p.p4 = (-1 + sqrt(5))/2.; p.pinf = (1 + sqrt(5))/2.; p.p21 = (1 - sqrt(5))/2.; p.p31 = 0; p.p32 = (1 + sqrt(5))/2.; p.p41 = 1; p.p42 = (1 + sqrt(5))/2.; p.p43 = (-1 - sqrt(5))/2.; p.p321 = 1; p.p432 = 1; p.p431 = -1; p.p421 = (-1 + sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(200).push_back(p);    
    p.p1 = (-1 - sqrt(5))/2.; p.p2 = 0; p.p3 = (1 - sqrt(5))/2.; p.p4 = 0; p.pinf = (1 + sqrt(5))/2.; p.p21 = (-1 + sqrt(5))/2.; p.p31 = 1; p.p32 = 0; p.p41 = (-1 + sqrt(5))/2.; p.p42 = (-1 + sqrt(5))/2.; p.p43 = 0; p.p321 = (-1 + sqrt(5))/2.; p.p432 = -2; p.p431 = (-1 + sqrt(5))/2.; p.p421 = -1;
    g.correct_values(p);
    transformed_p = g.el_sign_15(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p))))))))));
    points_p_ordered_by_length.at(200).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);    

    p.p1 = -1; p.p2 = 1; p.p3 = 1; p.p4 = (1 + sqrt(5))/2.; p.pinf = (1 - sqrt(5))/2.; p.p21 = 0; p.p31 = -1; p.p32 = (1 + sqrt(5))/2.; p.p41 = (-1 - sqrt(5))/2.; p.p42 = (1 + sqrt(5))/2.; p.p43 = 0; p.p321 = 0; p.p432 = (1 + sqrt(5))/2.; p.p431 = (1 - sqrt(5))/2.; p.p421 = (1 - sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(205).push_back(p);      
    p.p1 = (1 - sqrt(5))/2.; p.p2 = 1; p.p3 = -1; p.p4 = -1; p.pinf = (-1 - sqrt(5))/2.; p.p21 = (1 - sqrt(5))/2.; p.p31 = (1 + sqrt(5))/2.; p.p32 = (-1 + sqrt(5))/2.; p.p41 = -1; p.p42 = -1; p.p43 = (1 + sqrt(5))/2.; p.p321 = (-1 + sqrt(5))/2.; p.p432 = 1; p.p431 = -1; p.p421 = (-1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_3(g.el_sign_10(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p))))))));
    points_p_ordered_by_length.at(205).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);        
    p.p1 = (-1 - sqrt(5))/2.; p.p2 = (1 - sqrt(5))/2.; p.p3 = -1; p.p4 = -1; p.pinf = 1; p.p21 = 0; p.p31 = 0; p.p32 = -1; p.p41 = (-1 + sqrt(5))/2.; p.p42 = (1 + sqrt(5))/2.; p.p43 = 1; p.p321 = 1; p.p432 = (1 - sqrt(5))/2.; p.p431 = (1 - sqrt(5))/2.; p.p421 = -1;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_3(g.el_sign_10(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(p))))))));
    points_p_ordered_by_length.at(205).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);      
    p.p1 = -1; p.p2 = (-1 - sqrt(5))/2.; p.p3 = 1; p.p4 = (-1 + sqrt(5))/2.; p.pinf = 1; p.p21 = 1; p.p31 = -1; p.p32 = (-1 - sqrt(5))/2.; p.p41 = (1 - sqrt(5))/2.; p.p42 = -1; p.p43 = 0; p.p321 = (1 + sqrt(5))/2.; p.p432 = 0; p.p431 = (-1 - sqrt(5))/2.; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_10(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p))))));
    points_p_ordered_by_length.at(205).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);          
    
    p.p1 = -1; p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = 0; p.p21 = 0; p.p31 = sqrt(2); p.p32 = 1; p.p41 = -sqrt(2); p.p42 = 0; p.p43 = 1; p.p321 = -1; p.p432 = -sqrt(2); p.p431 = 0; p.p421 = -1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(216).push_back(p);       
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = -1; p.p21 = 1; p.p31 = 0; p.p32 = -1; p.p41 = 2; p.p42 = -1; p.p43 = 0; p.p321 = -sqrt(2); p.p432 = sqrt(2); p.p431 = 0; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_P_1inf(g.el_sign_1(p));
    points_p_ordered_by_length.at(216).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    
    p.p1 = -1; p.p2 = 1; p.p3 = (-1 + sqrt(5))/2.; p.p4 = -1; p.pinf = (-1 + sqrt(5))/2.; p.p21 = -1; p.p31 = (-1 - sqrt(5))/2.; p.p32 = (-1 + sqrt(5))/2.; p.p41 = (1 - sqrt(5))/2.; p.p42 = 0; p.p43 = (-1 - sqrt(5))/2.; p.p321 = (1 - sqrt(5))/2.; p.p432 = 0; p.p431 = (1 + sqrt(5))/2.; p.p421 = (1 - sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(220).push_back(p);      
    p.p1 = 1; p.p2 = -1; p.p3 = (-1 + sqrt(5))/2.; p.p4 = (1 - sqrt(5))/2.; p.pinf = 1; p.p21 = -1; p.p31 = -1; p.p32 = 0; p.p41 = (-1 - sqrt(5))/2.; p.p42 = (-1 + sqrt(5))/2.; p.p43 = -2; p.p321 = 1; p.p432 = 1; p.p431 = -1; p.p421 = (1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_3(g.el_sign_15(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)))))))));
    points_p_ordered_by_length.at(220).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);       
    p.p1 = (-1 + sqrt(5))/2.; p.p2 = 1; p.p3 = (-1 + sqrt(5))/2.; p.p4 = -1; p.pinf = -1; p.p21 = -1; p.p31 = 1; p.p32 = 0; p.p41 = 0; p.p42 = (-1 + sqrt(5))/2.; p.p43 = 1; p.p321 = 0; p.p432 = 1; p.p431 = 0; p.p421 = 1;
    g.correct_values(p);
    transformed_p = g.el_P_1inf(g.el_sign_1(p));
    points_p_ordered_by_length.at(220).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);       
    p.p1 = (-1 - sqrt(5))/2.; p.p2 = -1; p.p3 = -1; p.p4 = (-1 - sqrt(5))/2.; p.pinf = 1; p.p21 = (1 + sqrt(5))/2.; p.p31 = (-1 + sqrt(5))/2.; p.p32 = (1 + sqrt(5))/2.; p.p41 = (1 + sqrt(5))/2.; p.p42 = (-1 + sqrt(5))/2.; p.p43 = (-1 + sqrt(5))/2.; p.p321 = (-1 - sqrt(5))/2.; p.p432 = (1 - sqrt(5))/2.; p.p431 = -1; p.p421 = -1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(220).push_back(p);  
	p.p1 = (1 + sqrt(5))/2.; p.p2 = -1; p.p3 = 1; p.p4 = 1; p.pinf = (-1 - sqrt(5))/2.; p.p21 = 0; p.p31 = (-1 + sqrt(5))/2.; p.p32 = -1; p.p41 = 1; p.p42 = -1; p.p43 = 1; p.p321 = (1 - sqrt(5))/2.; p.p432 = -2; p.p431 = (1 + sqrt(5))/2.; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_10(g.el_sign_15(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)))))))));
    points_p_ordered_by_length.at(220).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);	    
    p.p1 = 1; p.p2 = (1 + sqrt(5))/2.; p.p3 = 1; p.p4 = (-1 - sqrt(5))/2.; p.pinf = -1; p.p21 = (1 + sqrt(5))/2.; p.p31 = (1 - sqrt(5))/2.; p.p32 = 1; p.p41 = -1; p.p42 = (-1 - sqrt(5))/2.; p.p43 = (-1 - sqrt(5))/2.; p.p321 = 0; p.p432 = (-1 - sqrt(5))/2.; p.p431 = 0; p.p421 = (-1 - sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_10(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)))))));
    points_p_ordered_by_length.at(220).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);	
    
    p.p1 = 1; p.p2 = (1 - sqrt(5))/2.; p.p3 = -1; p.p4 = (1 - sqrt(5))/2.; p.pinf = 0; p.p21 = 1; p.p31 = 0; p.p32 = (-1 + sqrt(5))/2.; p.p41 = (-1 - sqrt(5))/2.; p.p42 = 1; p.p43 = (-1 + sqrt(5))/2.; p.p321 = 0; p.p432 = (-1 + sqrt(5))/2.; p.p431 = 0; p.p421 = 1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(240).push_back(p);    
    p.p1 = 1; p.p2 = -1; p.p3 = (1 - sqrt(5))/2.; p.p4 = 0; p.pinf = (-1 + sqrt(5))/2.; p.p21 = 0; p.p31 = (-1 - sqrt(5))/2.; p.p32 = (-1 + sqrt(5))/2.; p.p41 = 1; p.p42 = (-1 + sqrt(5))/2.; p.p43 = (1 + sqrt(5))/2.; p.p321 = (1 + sqrt(5))/2.; p.p432 = -1; p.p431 = 1; p.p421 = -1;
    g.correct_values(p);
    transformed_p = g.el_sign_3(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p))))));
    points_p_ordered_by_length.at(240).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);   
    p.p1 = (1 - sqrt(5))/2.; p.p2 = (-1 + sqrt(5))/2.; p.p3 = -1; p.p4 = 1; p.pinf = 0; p.p21 = -1; p.p31 = (-1 + sqrt(5))/2.; p.p32 = (1 - sqrt(5))/2.; p.p41 = (-1 - sqrt(5))/2.; p.p42 = (-1 + sqrt(5))/2.; p.p43 = 0; p.p321 = (1 - sqrt(5))/2.; p.p432 = (-1 - sqrt(5))/2.; p.p431 = 0; p.p421 = -1;
    g.correct_values(p);
    transformed_p = g.el_sign_3(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))))))));
    points_p_ordered_by_length.at(240).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = (-1 + sqrt(5))/2.; p.p2 = 1; p.p3 = 0; p.p4 = 1; p.pinf = (-1 + sqrt(5))/2.; p.p21 = (1 + sqrt(5))/2.; p.p31 = 0; p.p32 = (1 - sqrt(5))/2.; p.p41 = (-1 + sqrt(5))/2.; p.p42 = 0; p.p43 = 1; p.p321 = (-1 + sqrt(5))/2.; p.p432 = 1; p.p431 = -1; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_sign_3(g.el_sign_10(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(p)))))));
    points_p_ordered_by_length.at(240).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = (1 - sqrt(5))/2.; p.p2 = 0; p.p3 = 0; p.p4 = (1 - sqrt(5))/2.; p.pinf = (-1 + sqrt(5))/2.; p.p21 = -1; p.p31 = -1; p.p32 = -2; p.p41 = (1 - sqrt(5))/2.; p.p42 = 0; p.p43 = 0; p.p321 = (-1 + sqrt(5))/2.; p.p432 = (-1 + sqrt(5))/2.; p.p431 = -1; p.p421 = -1;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(240).push_back(p);    
	p.p1 = (1 - sqrt(5))/2.; p.p2 = 0; p.p3 = (1 - sqrt(5))/2.; p.p4 = 0; p.pinf = (1 - sqrt(5))/2.; p.p21 = 0; p.p31 = 1; p.p32 = 0; p.p41 = (-1 - sqrt(5))/2.; p.p42 = (1 - sqrt(5))/2.; p.p43 = 0; p.p321 = (1 + sqrt(5))/2.; p.p432 = 2; p.p431 = 0; p.p421 = 1;
    g.correct_values(p);
    transformed_p = g.el_sign_3(g.el_perm_1(g.el_perm_1(g.el_perm_3(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)))))))))));
    points_p_ordered_by_length.at(240).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);    	    
    p.p1 = 1; p.p2 = -1; p.p3 = (-1 - sqrt(5))/2.; p.p4 = (1 + sqrt(5))/2.; p.pinf = 0; p.p21 = -1; p.p31 = (1 - sqrt(5))/2.; p.p32 = 0; p.p41 = (-1 + sqrt(5))/2.; p.p42 = (-1 - sqrt(5))/2.; p.p43 = (-1 - sqrt(5))/2.; p.p321 = 0; p.p432 = 1; p.p431 = 0; p.p421 = (1 - sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(240).push_back(p);      
    p.p1 = -1; p.p2 = (-1 - sqrt(5))/2.; p.p3 = 1; p.p4 = (-1 - sqrt(5))/2.; p.pinf = 0; p.p21 = 0; p.p31 = 0; p.p32 = 0; p.p41 = (1 + sqrt(5))/2.; p.p42 = 2; p.p43 = (-1 - sqrt(5))/2.; p.p321 = (1 - sqrt(5))/2.; p.p432 = 1; p.p431 = 1; p.p421 = -1;
    g.correct_values(p);
    transformed_p = g.el_sign_15(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))))))))));
    points_p_ordered_by_length.at(240).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);      
    p.p1 = -1; p.p2 = -1; p.p3 = 0; p.p4 = (1 + sqrt(5))/2.; p.pinf = (1 + sqrt(5))/2.; p.p21 = 0; p.p31 = 0; p.p32 = (1 - sqrt(5))/2.; p.p41 = -1; p.p42 = (-1 - sqrt(5))/2.; p.p43 = -1; p.p321 = (1 + sqrt(5))/2.; p.p432 = 0; p.p431 = 0; p.p421 = 1;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_7(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(p))))))));
    points_p_ordered_by_length.at(240).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);        
    p.p1 = 1; p.p2 = (-1 - sqrt(5))/2.; p.p3 = 1; p.p4 = 0; p.pinf = (-1 - sqrt(5))/2.; p.p21 = (1 - sqrt(5))/2.; p.p31 = 1; p.p32 = 0; p.p41 = -1; p.p42 = 0; p.p43 = 0; p.p321 = (1 - sqrt(5))/2.; p.p432 = (1 - sqrt(5))/2.; p.p431 = (-1 + sqrt(5))/2.; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_15(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p))))))));
    points_p_ordered_by_length.at(240).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = 0; p.p2 = (1 + sqrt(5))/2.; p.p3 = (-1 - sqrt(5))/2.; p.p4 = 0; p.pinf = (-1 - sqrt(5))/2.; p.p21 = 1; p.p31 = 0; p.p32 = -1; p.p41 = (1 + sqrt(5))/2.; p.p42 = -1; p.p43 = 0; p.p321 = (1 - sqrt(5))/2.; p.p432 = 1; p.p431 = -2; p.p421 = (1 + sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(240).push_back(p);      
    p.p1 = (-1 - sqrt(5))/2.; p.p2 = 0; p.p3 = (1 + sqrt(5))/2.; p.p4 = 0; p.pinf = (-1 - sqrt(5))/2.; p.p21 = 0; p.p31 = (-1 - sqrt(5))/2.; p.p32 = (-1 + sqrt(5))/2.; p.p41 = 0; p.p42 = (1 + sqrt(5))/2.; p.p43 = -1; p.p321 = -1; p.p432 = (1 + sqrt(5))/2.; p.p431 = (-1 + sqrt(5))/2.; p.p421 = -2;
    g.correct_values(p);
    transformed_p = g.el_sign_3(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)))))));
    points_p_ordered_by_length.at(240).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);         
    
    p.p1 = (1 + sqrt(5))/2.; p.p2 = 1; p.p3 = 1; p.p4 = 1; p.pinf = 1; p.p21 = 1; p.p31 = 0; p.p32 = 1; p.p41 = 1; p.p42 = (1 + sqrt(5))/2.; p.p43 = 1; p.p321 = 0; p.p432 = 1; p.p431 = 0; p.p421 = 2;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(300).push_back(p);  
	p.p1 = 1; p.p2 = (-1 + sqrt(5))/2.; p.p3 = 1; p.p4 = 1; p.pinf = -1; p.p21 = -1; p.p31 = (1 - sqrt(5))/2.; p.p32 = -1; p.p41 = 0; p.p42 = 0; p.p43 = (1 - sqrt(5))/2.; p.p321 = -2; p.p432 = -1; p.p431 = (-1 - sqrt(5))/2.; p.p421 = (-1 - sqrt(5))/2.;    
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(300).push_back(p);     
    
    p.p1 = 0; p.p2 = (-1 + sqrt(5))/2.; p.p3 = 0; p.p4 = -1; p.pinf = (-1 + sqrt(5))/2.; p.p21 = -1; p.p31 = -1; p.p32 = -1; p.p41 = 1; p.p42 = 1; p.p43 = 0; p.p321 = (-1 - sqrt(5))/2.; p.p432 = 1; p.p431 = (1 - sqrt(5))/2.; p.p421 = 0;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(360).push_back(p);     
    p.p1 = 1; p.p2 = (1 - sqrt(5))/2.; p.p3 = 0; p.p4 = 0; p.pinf = (-1 + sqrt(5))/2.; p.p21 = 1; p.p31 = 0; p.p32 = -1; p.p41 = 1; p.p42 = -1; p.p43 = (-1 + sqrt(5))/2.; p.p321 = 0; p.p432 = (-1 + sqrt(5))/2.; p.p431 = -1; p.p421 = (-1 - sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_3(g.el_sign_15(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p))))))))))));
    points_p_ordered_by_length.at(360).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = (1 - sqrt(5))/2.; p.p2 = 0; p.p3 = 0; p.p4 = (-1 - sqrt(5))/2.; p.pinf = 1; p.p21 = (1 + sqrt(5))/2.; p.p31 = (-1 - sqrt(5))/2.; p.p32 = 2; p.p41 = 1; p.p42 = 0; p.p43 = 0; p.p321 = (1 - sqrt(5))/2.; p.p432 = (-1 - sqrt(5))/2.; p.p431 = (1 + sqrt(5))/2.; p.p421 = (-1 - sqrt(5))/2.;
 	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(360).push_back(p);   
	p.p1 = 0; p.p2 = (1 - sqrt(5))/2.; p.p3 = 0; p.p4 = -1; p.pinf = (-1 - sqrt(5))/2.; p.p21 = -1; p.p31 = 1; p.p32 = 0; p.p41 = 1; p.p42 = (1 + sqrt(5))/2.; p.p43 = (-1 + sqrt(5))/2.; p.p321 = 1; p.p432 = -1; p.p431 = 0; p.p421 = (1 - sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_3(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p))))))));
    points_p_ordered_by_length.at(360).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = 1; p.p2 = 0; p.p3 = (-1 - sqrt(5))/2.; p.p4 = 0; p.pinf = (1 - sqrt(5))/2.; p.p21 = 1; p.p31 = 0; p.p32 = -1; p.p41 = -1; p.p42 = 1; p.p43 = 1; p.p321 = (-1 - sqrt(5))/2.; p.p432 = (1 - sqrt(5))/2.; p.p431 = (1 + sqrt(5))/2.; p.p421 = (1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)))))))));
    points_p_ordered_by_length.at(360).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = (1 + sqrt(5))/2.; p.p2 = 0; p.p3 = 0; p.p4 = -1; p.pinf = (1 - sqrt(5))/2.; p.p21 = (1 - sqrt(5))/2.; p.p31 = -1; p.p32 = (-1 - sqrt(5))/2.; p.p41 = 0; p.p42 = 1; p.p43 = 1; p.p321 = -1; p.p432 = 0; p.p431 = (1 + sqrt(5))/2.; p.p421 = (1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_15(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))))));
    points_p_ordered_by_length.at(360).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);      
    p.p1 = -1; p.p2 = 0; p.p3 = 0; p.p4 = (-1 + sqrt(5))/2.; p.pinf = (1 + sqrt(5))/2.; p.p21 = (1 + sqrt(5))/2.; p.p31 = 1; p.p32 = (-1 - sqrt(5))/2.; p.p41 = (-1 - sqrt(5))/2.; p.p42 = (1 + sqrt(5))/2.; p.p43 = 1; p.p321 = 1; p.p432 = -1; p.p431 = (-1 + sqrt(5))/2.; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_3(g.el_sign_15(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)))))))))));
    points_p_ordered_by_length.at(360).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);       
    p.p1 = (-1 + sqrt(5))/2.; p.p2 = 0; p.p3 = (1 + sqrt(5))/2.; p.p4 = 0; p.pinf = 1; p.p21 = 0; p.p31 = 1; p.p32 = (-1 + sqrt(5))/2.; p.p41 = 0; p.p42 = (1 + sqrt(5))/2.; p.p43 = 0; p.p321 = (1 - sqrt(5))/2.; p.p432 = (1 + sqrt(5))/2.; p.p431 = -1; p.p421 = (1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_15(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p))))))))))))))));
    points_p_ordered_by_length.at(360).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = 1; p.p2 = 0; p.p3 = (-1 - sqrt(5))/2.; p.p4 = 0; p.pinf = (-1 - sqrt(5))/2.; p.p21 = -1; p.p31 = 0; p.p32 = 0; p.p41 = 0; p.p42 = (1 + sqrt(5))/2.; p.p43 = (-1 + sqrt(5))/2.; p.p321 = (-1 + sqrt(5))/2.; p.p432 = (-1 - sqrt(5))/2.; p.p431 = 0; p.p421 = (-1 + sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(360).push_back(p);     
	p.p1 = 0; p.p2 = 0; p.p3 = -1; p.p4 = (1 + sqrt(5))/2.; p.pinf = (-1 - sqrt(5))/2.; p.p21 = (1 + sqrt(5))/2.; p.p31 = 1; p.p32 = (-1 - sqrt(5))/2.; p.p41 = 1; p.p42 = -1; p.p43 = (-1 - sqrt(5))/2.; p.p321 = (1 - sqrt(5))/2.; p.p432 = -1; p.p431 = (-1 + sqrt(5))/2.; p.p421 = (1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))));
    points_p_ordered_by_length.at(360).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     	    
    
    p.p1 = 1; p.p2 = -1; p.p3 = 1; p.p4 = 1; p.pinf = -1; p.p21 = -1; p.p31 = 0; p.p32 = 0; p.p41 = (1 - sqrt(5))/2.; p.p42 = -1; p.p43 = 1; p.p321 = -1; p.p432 = (-1 - sqrt(5))/2.; p.p431 = (1 - sqrt(5))/2.; p.p421 = (-1 + sqrt(5))/2.;
	g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(432).push_back(p);         
    
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = (-1 + sqrt(5))/2.; p.pinf = (-1 + sqrt(5))/2.; p.p21 = (-1 - sqrt(5))/2.; p.p31 = 0; p.p32 = 1; p.p41 = 0; p.p42 = 1; p.p43 = -1; p.p321 = (1 - sqrt(5))/2.; p.p432 = -1; p.p431 = (-1 - sqrt(5))/2.; p.p421 = 0;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(480).push_back(p);   
    p.p1 = 0; p.p2 = 0; p.p3 = (1 + sqrt(5))/2.; p.p4 = 0; p.pinf = (1 + sqrt(5))/2.; p.p21 = 0; p.p31 = 1; p.p32 = 0; p.p41 = (-1 + sqrt(5))/2.; p.p42 = (-1 - sqrt(5))/2.; p.p43 = (1 - sqrt(5))/2.; p.p321 = (-1 + sqrt(5))/2.; p.p432 = -1; p.p431 = 0; p.p421 = 1;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(480).push_back(p);       
    
    p.p1 = (1 - sqrt(5))/2.; p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = (1 + sqrt(5))/2.; p.p21 = 0; p.p31 = (1 + sqrt(5))/2.; p.p32 = -1; p.p41 = 0; p.p42 = -2; p.p43 = -1; p.p321 = (-1 + sqrt(5))/2.; p.p432 = 0; p.p431 = 0; p.p421 = (-1 + sqrt(5))/2.;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(580).push_back(p);     
    p.p1 = (-1 - sqrt(5))/2.; p.p2 = 0; p.p3 = 0; p.p4 = (1 - sqrt(5))/2.; p.pinf = 0; p.p21 = 0; p.p31 = (-1 + sqrt(5))/2.; p.p32 = (1 + sqrt(5))/2.; p.p41 = 0; p.p42 = -1; p.p43 = (1 + sqrt(5))/2.; p.p321 = (-1 - sqrt(5))/2.; p.p432 = 0; p.p431 = -2; p.p421 = (1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_3(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p))));
    points_p_ordered_by_length.at(580).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = 0; p.p2 = 0; p.p3 = (1 + sqrt(5))/2.; p.p4 = 0; p.pinf = (-1 + sqrt(5))/2.; p.p21 = (-1 - sqrt(5))/2.; p.p31 = (1 - sqrt(5))/2.; p.p32 = -1; p.p41 = (-1 - sqrt(5))/2.; p.p42 = (1 - sqrt(5))/2.; p.p43 = 0; p.p321 = (-1 - sqrt(5))/2.; p.p432 = -1; p.p431 = (-1 - sqrt(5))/2.; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_3(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(p))))));
    points_p_ordered_by_length.at(580).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);       
    p.p1 = (-1 + sqrt(5))/2.; p.p2 = 0; p.p3 = (-1 - sqrt(5))/2.; p.p4 = 0; p.pinf = 0; p.p21 = (1 + sqrt(5))/2.; p.p31 = 0; p.p32 = 0; p.p41 = (-1 - sqrt(5))/2.; p.p42 = 1; p.p43 = (-1 + sqrt(5))/2.; p.p321 = -1; p.p432 = 0; p.p431 = 1; p.p421 = (-1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(p)))))));
    points_p_ordered_by_length.at(580).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);    
    
    p.p1 = 0; p.p2 = -1; p.p3 = 0; p.p4 = (1 - sqrt(5))/2.; p.pinf = -1; p.p21 = 0; p.p31 = (1 - sqrt(5))/2.; p.p32 = 1; p.p41 = (-1 - sqrt(5))/2.; p.p42 = 0; p.p43 = -1; p.p321 = (1 + sqrt(5))/2.; p.p432 = 1; p.p431 = (1 - sqrt(5))/2.; p.p421 = (1 + sqrt(5))/2.;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(600).push_back(p);     
    p.p1 = 1; p.p2 = 0; p.p3 = 0; p.p4 = (1 - sqrt(5))/2.; p.pinf = -1; p.p21 = 1; p.p31 = (-1 - sqrt(5))/2.; p.p32 = (1 + sqrt(5))/2.; p.p41 = 0; p.p42 = (-1 - sqrt(5))/2.; p.p43 = 1; p.p321 = (-1 + sqrt(5))/2.; p.p432 = -1; p.p431 = 1; p.p421 = (1 - sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(p)))))))));
    points_p_ordered_by_length.at(600).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);        
    p.p1 = (-1 - sqrt(5))/2.; p.p2 = 1; p.p3 = 0; p.p4 = 0; p.pinf = 1; p.p21 = -1; p.p31 = (-1 + sqrt(5))/2.; p.p32 = -1; p.p41 = (-1 + sqrt(5))/2.; p.p42 = -1; p.p43 = -2; p.p321 = (1 + sqrt(5))/2.; p.p432 = -1; p.p431 = (1 + sqrt(5))/2.; p.p421 = (1 + sqrt(5))/2.;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(600).push_back(p);    
	p.p1 = 0; p.p2 = 1; p.p3 = 0; p.p4 = (-1 - sqrt(5))/2.; p.pinf = -1; p.p21 = -1; p.p31 = (1 - sqrt(5))/2.; p.p32 = 0; p.p41 = 0; p.p42 = (1 - sqrt(5))/2.; p.p43 = 1; p.p321 = 1; p.p432 = 1; p.p431 = 1; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_sign_7(g.el_sign_3(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))))))));
    points_p_ordered_by_length.at(600).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     	    
    
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = -1; p.pinf = (-1 + sqrt(5))/2.; p.p21 = 0; p.p31 = (1 + sqrt(5))/2.; p.p32 = (-1 + sqrt(5))/2.; p.p41 = (1 - sqrt(5))/2.; p.p42 = (-1 - sqrt(5))/2.; p.p43 = 1; p.p321 = 1; p.p432 = 0; p.p431 = (-1 - sqrt(5))/2.; p.p421 = 0;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(900).push_back(p);      
    p.p1 = -1; p.p2 = 0; p.p3 = (-1 + sqrt(5))/2.; p.p4 = 0; p.pinf = 0; p.p21 = 1; p.p31 = 0; p.p32 = 0; p.p41 = 0; p.p42 = (-1 - sqrt(5))/2.; p.p43 = 0; p.p321 = (1 + sqrt(5))/2.; p.p432 = (-1 + sqrt(5))/2.; p.p431 = (-1 - sqrt(5))/2.; p.p421 = 1;
    g.correct_values(p);
    transformed_p = g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))))));
    points_p_ordered_by_length.at(900).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);      
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = (1 - sqrt(5))/2.; p.pinf = -1; p.p21 = 0; p.p31 = -1; p.p32 = (1 + sqrt(5))/2.; p.p41 = -1; p.p42 = 0; p.p43 = -1; p.p321 = (-1 + sqrt(5))/2.; p.p432 = -1; p.p431 = -1; p.p421 = (1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)))))));
    points_p_ordered_by_length.at(900).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = 0; p.p2 = 0; p.p3 = (1 - sqrt(5))/2.; p.p4 = 1; p.pinf = 0; p.p21 = -1; p.p31 = -1; p.p32 = 0; p.p41 = (-1 + sqrt(5))/2.; p.p42 = (1 + sqrt(5))/2.; p.p43 = 0; p.p321 = -1; p.p432 = -1; p.p431 = -2; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_sign_15(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(p)))))));
    points_p_ordered_by_length.at(900).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = -1; p.pinf = (-1 - sqrt(5))/2.; p.p21 = 0; p.p31 = 1; p.p32 = (-1 + sqrt(5))/2.; p.p41 = (-1 - sqrt(5))/2.; p.p42 = (-1 + sqrt(5))/2.; p.p43 = (-1 + sqrt(5))/2.; p.p321 = (1 + sqrt(5))/2.; p.p432 = 1; p.p431 = 0; p.p421 = 0;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(900).push_back(p);     
    p.p1 = 0; p.p2 = 0; p.p3 = (-1 - sqrt(5))/2.; p.p4 = 0; p.pinf = -1; p.p21 = (-1 - sqrt(5))/2.; p.p31 = 0; p.p32 = (1 - sqrt(5))/2.; p.p41 = (1 + sqrt(5))/2.; p.p42 = 2; p.p43 = (-1 + sqrt(5))/2.; p.p321 = (1 + sqrt(5))/2.; p.p432 = (-1 - sqrt(5))/2.; p.p431 = -1; p.p421 = 0;
    g.correct_values(p);
    transformed_p = g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))))));
    points_p_ordered_by_length.at(900).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);      
    p.p1 = 0; p.p2 = (-1 - sqrt(5))/2.; p.p3 = 0; p.p4 = 1; p.pinf = 0; p.p21 = 1; p.p31 = (-1 + sqrt(5))/2.; p.p32 = (1 - sqrt(5))/2.; p.p41 = 1; p.p42 = -1; p.p43 = (1 - sqrt(5))/2.; p.p321 = -1; p.p432 = 1; p.p431 = -1; p.p421 = (1 - sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_15(g.el_perm_1(g.el_P_1inf(g.el_sign_1(g.el_perm_1(g.el_perm_1(g.el_perm_1(p))))))));
    points_p_ordered_by_length.at(900).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);    
    p.p1 = 0; p.p2 = 0; p.p3 = 1; p.p4 = (-1 - sqrt(5))/2.; p.pinf = 0; p.p21 = (-1 + sqrt(5))/2.; p.p31 = 0; p.p32 = (1 + sqrt(5))/2.; p.p41 = 0; p.p42 = 0; p.p43 = -1; p.p321 = (-1 + sqrt(5))/2.; p.p432 = -1; p.p431 = -1; p.p421 = (-1 + sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_sign_1(g.el_sign_15(g.el_P_1inf(g.el_sign_1(g.el_perm_1(p)))));
    points_p_ordered_by_length.at(900).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);        
    
    p.p1 = 0; p.p2 = 0; p.p3 = (1 - sqrt(5))/2.; p.p4 = 0; p.pinf = 0; p.p21 = (-1 + sqrt(5))/2.; p.p31 = 1; p.p32 = 1; p.p41 = -1; p.p42 = -1; p.p43 = 1; p.p321 = (-1 + sqrt(5))/2.; p.p432 = (1 + sqrt(5))/2.; p.p431 = -1; p.p421 = 1;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(1200).push_back(p);    
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = (-1 + sqrt(5))/2.; p.p21 = (1 + sqrt(5))/2.; p.p31 = (1 - sqrt(5))/2.; p.p32 = (1 + sqrt(5))/2.; p.p41 = 0; p.p42 = (1 - sqrt(5))/2.; p.p43 = 1; p.p321 = 0; p.p432 = 1; p.p431 = (-1 - sqrt(5))/2.; p.p421 = 1;
    g.correct_values(p);
    transformed_p = g.el_sign_7(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))));
    points_p_ordered_by_length.at(1200).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
    p.p1 = 0; p.p2 = (1 + sqrt(5))/2.; p.p3 = 0; p.p4 = 0; p.pinf = 0; p.p21 = (1 - sqrt(5))/2.; p.p31 = 1; p.p32 = (-1 + sqrt(5))/2.; p.p41 = 1; p.p42 = 0; p.p43 = 1; p.p321 = (1 + sqrt(5))/2.; p.p432 = 0; p.p431 = 0; p.p421 = 0;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(1200).push_back(p);       
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = (-1 - sqrt(5))/2.; p.p21 = (1 + sqrt(5))/2.; p.p31 = -1; p.p32 = (1 + sqrt(5))/2.; p.p41 = -1; p.p42 = 1; p.p43 = (-1 - sqrt(5))/2.; p.p321 = (-1 + sqrt(5))/2.; p.p432 = (-1 + sqrt(5))/2.; p.p431 = -1; p.p421 = 1;
    g.correct_values(p);
    transformed_p = g.el_sign_3(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p))));
    points_p_ordered_by_length.at(1200).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);         
    
    p.p1 = 1; p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = -1; p.p21 = 1; p.p31 = 1; p.p32 = -1; p.p41 = 1; p.p42 = -1; p.p43 = -2; p.p321 = (-1 + sqrt(5))/2.; p.p432 = 0; p.p431 = -1; p.p421 = (-1 + sqrt(5))/2.;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(1440).push_back(p);     
    
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = -1; p.pinf = 0; p.p21 = 1; p.p31 = (1 - sqrt(5))/2.; p.p32 = (1 + sqrt(5))/2.; p.p41 = (1 - sqrt(5))/2.; p.p42 = (1 + sqrt(5))/2.; p.p43 = -1; p.p321 = -1; p.p432 = (1 - sqrt(5))/2.; p.p431 = -1; p.p421 = 0;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(2160).push_back(p);   
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = -1; p.p21 = -1; p.p31 = (-1 - sqrt(5))/2.; p.p32 = (1 - sqrt(5))/2.; p.p41 = (-1 + sqrt(5))/2.; p.p42 = 0; p.p43 = (1 + sqrt(5))/2.; p.p321 = 1; p.p432 = 1; p.p431 = 0; p.p421 = (-1 - sqrt(5))/2.;
    g.correct_values(p);
    transformed_p = g.el_perm_1(g.el_perm_1(g.el_perm_1(g.el_P_1inf(g.el_sign_1(p)))));
    points_p_ordered_by_length.at(2160).push_back(transformed_p);	
    g.print_g2_coords(transformed_p);     
        
    p.p1 = 0; p.p2 = 0; p.p3 = 0; p.p4 = 0; p.pinf = 0; p.p21 = (-1 - sqrt(5))/2.; p.p31 = 0; p.p32 = -1; p.p41 = (-1 - sqrt(5))/2.; p.p42 = (1 - sqrt(5))/2.; p.p43 = 1; p.p321 = (1 - sqrt(5))/2.; p.p432 = -1; p.p431 = (1 - sqrt(5))/2.; p.p421 = 0;
    g.correct_values(p);
    g.print_g2_coords(p);
	points_p_ordered_by_length.at(3072).push_back(p);     

	for(int ii = 0; ii < points_p_ordered_by_length.size(); ii++){
		if(points_p_ordered_by_length.at(ii).size() > 0){
			std::cout << "There are " << points_p_ordered_by_length.at(ii).size() << " orbits of size " << ii << std::endl;
		}
	}
	points_p.clear();
 
	std::string str2 ("C2");
	std::cout << "Classification saved on file " << ("./" + str2) << std::endl;
	std::ofstream out_file;
	std::cout << "Algorithm 11 Started..." << std::endl;
	try{
		out_file.open( str2.c_str() , std::ios::binary | std::ios::app );
		//set A_N corresponds to points_p_ordered_by_length.at(N)
 		for( int ii = 0; ii < points_p_ordered_by_length.size(); ii++ ){ 
 			if(points_p_ordered_by_length.at(ii).size() == 0){ continue; }

			hash_table_loc.clear();
			std::cout << "Start loading orbits of size " << ii << std::endl;
			points_p.clear();
			points_p = points_p_ordered_by_length.at(ii);
			std::cout << "Loaded " <<points_p_ordered_by_length.at(ii).size() << " orbits" << std::endl;
			//expand the orbits
			std::cout << "Calculate orbits." << std::endl;
			hash_tables_orbits.clear();
			for(int jj = 0; jj < points_p.size(); jj++ ){
			    //init before calculating orbit
				p = points_p.at(jj);
				g.correct_values( p );
				g.max_recursion_g2 = 100000;
				g.hash_table_orbit.clear();
				orbit_points.clear();
				//calculate P4 orbit of p
				g.gen_orbit_g2_( p , orbit_points );
// 				g.gen_orbit_g2_norecurs_( p , orbit_points );
				hash_tables_orbits.push_back( g.hash_table_orbit );
				g2::g2_coords_pi pi;
			}
			std::cout << "End." << std::endl;

			std::cout << "Quotienting orbits of size " <<  ii << " ." << std::endl;
			hash_tables_orbits_t = hash_tables_orbits_t2 = hash_tables_orbits;
			pi_vec_t = pi_vec;
			int cc1 = 0;
			cc2 = 0;
			do{
				sz_1 = hash_tables_orbits_t.size();
				for (it_o=hash_tables_orbits.begin(); it_o!=hash_tables_orbits.end(); it_o++){
					p.p1 = it_o->begin()->second.at(0);
					p.p2 = it_o->begin()->second.at(1);
					p.p3 = it_o->begin()->second.at(2);
					p.p4 = it_o->begin()->second.at(3);
					p.pinf = it_o->begin()->second.at(4);
					p.p21 = it_o->begin()->second.at(5);
					p.p31 = it_o->begin()->second.at(6);
					p.p32 = it_o->begin()->second.at(7);
					p.p41 = it_o->begin()->second.at(8);
					p.p42 = it_o->begin()->second.at(9);
					p.p43 = it_o->begin()->second.at(10);
					p.p321 = it_o->begin()->second.at(11);
					p.p432 = it_o->begin()->second.at(12);
					p.p431 = it_o->begin()->second.at(13);
					p.p421 = it_o->begin()->second.at(14);
					cc1=0;
					g.correct_values( p );
					g.print_g2_coords(p);
					std::vector<g2::g2_coords > P_IJ_group_vec; 
					P_IJ_group_vec.clear();
					g.max_recursion_g2 = 1000000;
					g.hash_table_orbit.clear();
					//apply to p the group <P13,P34,P23>
					g.gen_P12_P23_P34_group_( p , P_IJ_group_vec );
					for( int ii1 = 0 ; ii1 < P_IJ_group_vec.size() ; ii1++ ){
						g.correct_values( P_IJ_group_vec.at(ii1) );				
						transformed_p = P_IJ_group_vec.at(ii1);		
                        //check if p' is inside any orbit
						for (int ii2 = 0; ii2 < hash_tables_orbits_t.size(); ii2++ ){
						    //generate the key of p'
							std::vector<double> p_double = { transformed_p.p1, transformed_p.p2, transformed_p.p3, transformed_p.p4, transformed_p.pinf, transformed_p.p21, transformed_p.p31, transformed_p.p32, transformed_p.p41, transformed_p.p42, transformed_p.p43, transformed_p.p321, transformed_p.p432, transformed_p.p431, transformed_p.p421 };
							std::size_t hash_t = make_hash(p_double);
							//if p' is not in the orbit, pass to check if p' is in the next orbit
							if(	hash_tables_orbits_t.at(ii2).count(hash_t) == 0 ){
								continue;
							}else{
								//check if the two vectors are the same
								std::vector<double > double_p_t = hash_tables_orbits_t.at(ii2).find( hash_t )->second;
								if(
									fabs(double_p_t.at(0) - p_double.at(0)) && fabs(double_p_t.at(1) - p_double.at(1)) &&
									fabs(double_p_t.at(2) - p_double.at(2)) && fabs(double_p_t.at(3) - p_double.at(3)) &&
									fabs(double_p_t.at(4) - p_double.at(4)) && fabs(double_p_t.at(5) - p_double.at(5)) &&
									fabs(double_p_t.at(6) - p_double.at(6)) && fabs(double_p_t.at(7) - p_double.at(7)) &&
									fabs(double_p_t.at(8) - p_double.at(8)) && fabs(double_p_t.at(9) - p_double.at(9)) &&
									fabs(double_p_t.at(10) - p_double.at(10)) && fabs(double_p_t.at(11) - p_double.at(11)) &&
									fabs(double_p_t.at(12) - p_double.at(12)) && fabs(double_p_t.at(13) - p_double.at(13)) &&
									fabs(double_p_t.at(14) - p_double.at(14)) 
								){
									std::cout << "Err. the two vectors are not equal" << std::endl;	
									return 0;
								}
								hash_tables_quotient_orbits.push_back( transformed_p );
								hash_tables_orbits_t2.erase( hash_tables_orbits_t2.begin() + ii2 );
								break;
							}//end if
						}//end for ii2
						hash_tables_orbits_t = hash_tables_orbits_t2;
					};//end for					
					std::cout << "Eliminated " << hash_tables_quotient_orbits.size() << " equivalent orbits of size " << ii << std::endl;
					//create the "delimiter" : a point "p" where in p1 there is the dimension of the orbit
					g2::g2_coords delimiter;
                	delimiter.p1 = (double) ii;
                	delimiter.p2 = (double) cc2;
                	out_file.write(reinterpret_cast<char *>(&delimiter), sizeof(delimiter));
					p = hash_tables_quotient_orbits.at(0);
					hash_tables_quotient_orbits.clear();
					out_file.write(reinterpret_cast<char *>(&p), sizeof(p));
					break;
				 }//end for
				 hash_tables_orbits = hash_tables_orbits_t;
			}while( sz_1 > hash_tables_orbits_t.size() );	
/* ------------------------------------------------------------------------------------------------------------------------------------------------------------ */    
		}//end for ii
		out_file.close();
 	}catch (std::ofstream::failure e) {
        std::cerr << "Error: ";
    }
    return 0;
}